#!/bin/bash

RESET="\033[0m"
RED="\033[1m\033[31m"
BLUE="\033[1m\033[34m"
YELLOW="\033[1m\033[33m"
GREEN="\033[1m\033[32m"

function print_usage {
    printf " Usage: ./read-efuses [OPTIONS]\n"
    printf "\n"
    printf " Options:\n"
    printf "     -r     YARR controller configuration file\n"
    printf "     -c     YARR connectivity configuration file\n"
    printf "     -h     show this help message\n"
}

function main {
    controller_config=""
    connectivity_config=""
    while test $# -gt 0
    do
        case $1 in
            -h)
                print_usage
                return 0
                ;;
            -r)
                controller_config=${2}
                shift
                ;;
            -c)
                connectivity_config=${2}
                shift
                ;;
        esac
        shift
    done

    if [ "${controller_config}" == "" ]; then
        printf "${RED}[EFUSE-PROG] [ERROR]${RESET} Failed to provide YARR controller configuration file\n"
        return 1
    fi
    if [ "${connectivity_config}" == "" ]; then
        printf "${RED}[EFUSE-PROG] [ERROR]${RESET} Failed to provide YARR connectivity configuration file\n"
        return 1
    fi

    readback=$(@CMAKE_BINARY_DIR@/bin/program-efuses -r ${controller_config} -c ${connectivity_config})
    readback=${readback/0x/}
    printf "${GREEN}[EFUSE-PROG]${RESET} E-fuse data readback : 0x${readback}\n"
    return 0
}

#____________________
main $*
